/* 
 * BERcut-ET. Gigabit Ethernet analyser.
 * Copyright (C) 2008 by NTC-Metrotek, SPb. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 *
 * http://metrotek.spb.ru
 * support@metrotek.spb.ru
 *
 */

#include "crc16.h"

unsigned short crc16b( const void *data, unsigned short size, unsigned short crc )
{
  char i;
  unsigned char *ptr = ( unsigned char * ) data;
  while( size-- > 0 ) {
    crc = crc ^ ( unsigned short ) *ptr++ << 8;
    i = 8;
    do {
      if( crc & 0x8000 )
        crc = crc << 1 ^ 0x1021;
      else
        crc = crc << 1;
    } while( --i );
  }
  return crc;
}



unsigned short crc16( const void * data, unsigned short size )
{
  return crc16b( data, size, 0xFFFF );
}


